package ics332.rc.v4;

import ics332.rc.common.AbstractCounter;

/**
 * A thread-safe counter implementation: synchronized methods
 */
public class Counter extends AbstractCounter {
	public Counter(int initialCounterValue, boolean debug) {
		super(initialCounterValue, debug);
	}
	
	public synchronized void increment() {
		if (debug) {
			System.out.println("Before increment: " + this.counterValue);
		}
		this.counterValue += 1;
		if (debug) {
			System.out.println(" After increment: " + this.counterValue);
		}
	}
	public synchronized void decrement() {
		if (debug) {
			System.out.println("Before decrement: " + this.counterValue);
		}
		this.counterValue -= 1;
		if (debug) {
			System.out.println(" After decrement: " + this.counterValue);
		}
	}
}
