package ics332.rc.v4;

import ics332.rc.common.DecrementingThread;
import ics332.rc.common.IncrementingThread;

public class RaceConditionExample {
	public static void main(String[] args) {
		int nbIterations = 10_000_000;
		Counter counter = new Counter(0, false);
		
		Thread incrementingThread = new IncrementingThread(counter, nbIterations);
		Thread decrementingThread = new DecrementingThread(counter, nbIterations);
		
		System.out.println("Initial value: " + counter.getCounterValue());
		
		incrementingThread.start();
		decrementingThread.start();
		
		try {
			incrementingThread.join();
			decrementingThread.join();
			System.out.println("Final value: " + counter.getCounterValue());
			System.out.println("  for " + nbIterations + " iterations using " + RaceConditionExample.class.getName());
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
