package ics332.rc.v5;

import ics332.rc.common.AbstractCounter;

/**
 * A thread-safe counter implementation: synchronized blocks
 */
public class Counter extends AbstractCounter {
	public Counter(int initialCounterValue, boolean debug) {
		super(initialCounterValue, debug);
	}
	
	public void increment() {
		if (debug) {
			System.out.println("Before increment: " + this.counterValue);
		}
		synchronized (this) {
			this.counterValue += 1;
		}
		if (debug) {
			System.out.println(" After increment: " + this.counterValue);
		}
	}
	public void decrement() {
		if (debug) {
			System.out.println("Before decrement: " + this.counterValue);
		}
		synchronized (this) {
			this.counterValue -= 1;
		}
		if (debug) {
			System.out.println(" After decrement: " + this.counterValue);
		}
	}
}
